from math import ceil

def conversor(archivo_imgPPM):

    f = open(archivo_imgPPM, 'r')                                           # Abre la imagen PPM para lectura y procesado

    archivo_imgRGB565 = archivo_imgPPM[0:archivo_imgPPM.find('.')]+"_565"
    g = open(archivo_imgRGB565+".py", 'w')                                  # Crea el módulo con la imagen en formato RGB565

                                          # LECTURA DEL ENCABEZAMIENTO DEL FICHERO CON LA IMAGEN PPM
    magic_number = f.readline()           # Número mágico
    f.readline()                          # Comentario -se ignora-
    width_height = f.readline().split()   # Ancho / Alto en pixels
    f.readline()                          # Valor máximo RGB -se ignora-

    pixels_ancho = int(width_height[0])
    pixels_alto = int(width_height[1])
    
    lineas_bloque = 60

    if magic_number == "P3\n":
        
        g.write("PIXELS_ANCHO = " + str(pixels_ancho) + "\n")
        g.write("PIXELS_ALTO = " + str(pixels_alto) + "\n")
        
        if ceil(pixels_alto/lineas_bloque) > 1:
            g.write("BLOQUES = "+ str(ceil(pixels_alto/lineas_bloque)) +
                    "    # Divide la imagen en bloques ≤ "+str(lineas_bloque)+" pixels de altura\n")
                
        for y in range(pixels_alto):
            print("Línea ",y+1)
            
            if y%lineas_bloque == 0:
                g.write("\n_BLOQUE_0"+str(y//lineas_bloque+1)+"=\\\n") 
                    
            g.write("b'")
            for x in range(pixels_ancho):
                
                red = int(f.readline())
                green = int(f.readline())
                blue = int(f.readline())           
                
                high_565 =((red & 0b11111000)+((green & 0b11100000)>>5))   # byte alto 565 8bits
                str_hex_high_565 = str(hex(high_565))[2:]
                if len(str_hex_high_565) == 1:
                    str_hex_high_565 = "0"+str_hex_high_565
                g.write("\\x"+str_hex_high_565)

                low_565 = (((green & 0b00011100)<<3)+(blue>>3))            # byte bajo 565 8bits
                str_hex_low_565 = str(hex(low_565))[2:]
                if len(str_hex_low_565) == 1:
                    str_hex_low_565 = "0"+str_hex_low_565
                g.write("\\x"+str_hex_low_565)

            g.write("'\\\n")
            
            if y>0 and (y+1)%lineas_bloque == 0 or (y+1) == pixels_alto:
                g.write("\nBLOQUE_0"+str(y//lineas_bloque+1)+" = memoryview(_BLOQUE_0"+str(y//lineas_bloque+1)+")\n\n")
        
        f.close()
        g.close()
          
        h = open(archivo_imgRGB565+"_visor.py", "w")           # Crea el módulo para visualizar la imgen en el ST7789

        code_01 ="""from machine import Pin, SPI
import st7789, {archivo_imgRGB565}                

tft = st7789.ST7789(
    SPI(2, baudrate=30000000, polarity=1, phase=1, sck=Pin(18), mosi=Pin(19)),
    135,
    240,
    reset=Pin(23, Pin.OUT),
    cs=Pin(5, Pin.OUT),
    dc=Pin(16, Pin.OUT),
    backlight=Pin(4, Pin.OUT),
    rotation=0)

tft.init()\n\n""".format(archivo_imgRGB565 = archivo_imgRGB565)
        h.write(code_01)
        
        if ceil(pixels_alto/lineas_bloque) == 1:    
            h.write("tft.blit_buffer("+archivo_imgRGB565+".BLOQUE_01, 0, 0  ,"+str(pixels_ancho)+", "+str(pixels_alto)+")")
    
        else:
            h.write("def imagen(x,y):\n")
            for x in range (ceil(pixels_alto/lineas_bloque)-1):
                h.write("    tft.blit_buffer("+archivo_imgRGB565+".BLOQUE_0"+str(x+1)+", x, y+"+str(x)+
                        "*"+str(lineas_bloque)+" ,"+str(pixels_ancho)+", "+str(lineas_bloque)+")\n")
            h.write("    tft.blit_buffer("+archivo_imgRGB565+".BLOQUE_0"+str(ceil(pixels_alto/lineas_bloque))+
                    ", x, y+"+str(ceil(pixels_alto/lineas_bloque)-1)+"*"+str(lineas_bloque)+
                    " ,"+str(pixels_ancho)+", "+str(pixels_alto-lineas_bloque*(ceil(pixels_alto/lineas_bloque)-1))+")\n")
            h.write("\nimagen(0,0)")
    
        h.close()
                
        print ("ok")
    
    else:
        print("Formato de dibujo incorrecto. Debe ser un fichero .ppm en formato ASCII (Número mágico: P3).") 
